#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <linux/ioctl.h>
#include <linux/miscdevice.h>

#define NB_READ 50
#define ADC_DEV_NAME "/dev/ucb1x00-adc"

int main(int argc, char *argv[])
{
  int adc_dev, ii, cc;
  struct misc_adc adc_data;

  printf("\n\n   ***   test_adc   ***\n\n");
  printf("Basic test for UCB1400 ADC driver\n\n");
  
  adc_dev = open(ADC_DEV_NAME, O_RDWR);
  if (adc_dev < 0) {
    printf("%s ", ADC_DEV_NAME);
    perror("open failed");
    exit(1);
  }
  else {
    printf("%s open succeeded.\n", ADC_DEV_NAME);
    adc_data.channel_count = 4;
    adc_data.channel[0].number = 0;
    adc_data.channel[1].number = 1;
    adc_data.channel[2].number = 2;
    adc_data.channel[3].number = 3;
    for (ii=0; ii<NB_READ; ii++) {
      sleep(1);
      if (ioctl(adc_dev, MISCIOCADC, (void*) &adc_data) < 0) {
	perror("ioctl ADC");
	break;
      }
      else {
	printf("% 4d: ", ii);
	for (cc=0; cc<adc_data.channel_count; cc++)
	  printf("% 4u  ", adc_data.channel[cc].value);
	printf("\n");
      }
    }
    close(adc_dev);
  }
}
