#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <linux/ioctl.h>
#include <linux/miscdevice.h>

#define NB_READ 1000
#define ADC_DEV_NAME "/dev/ucb1x00-adc"

int main(int argc, char *argv[])
{
  int adc_dev, ii;
  struct misc_adc adc_data;
  struct timeval tvs, tve;

  printf("\n\n   ***   test_adc_speed   ***\n\n");
  printf("Speed test for UCB1400 ADC driver\n\n");

  adc_dev = open(ADC_DEV_NAME, O_RDWR);
  if (adc_dev < 0) {
    printf("%s ", ADC_DEV_NAME);
    perror("open failed");
    exit(1);
  }
  else {
    printf("%s open succeeded.\n", ADC_DEV_NAME);
    adc_data.channel_count = 4;
    adc_data.channel[0].number = 0;
    adc_data.channel[1].number = 1;
    adc_data.channel[2].number = 2;
    adc_data.channel[3].number = 3;
    gettimeofday(&tvs, NULL);
    for (ii=0; ii<NB_READ; ii++) {
      if (ioctl(adc_dev, MISCIOCADC, (void*) &adc_data) < 0) {
	perror("ioctl ADC");
	break;
      }
    }
    gettimeofday(&tve, NULL);
    printf("%ld.%06d - %ld.%06d, %d conversions\n",
	   tvs.tv_sec, tvs.tv_usec, tve.tv_sec, tve.tv_usec, NB_READ);
    close(adc_dev);
  }
}
