#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <pthread.h>
#include <asm/errno.h>

void *thread2(void *arg)
{
  printf("Thread2 starting...\n");
  sleep(1);
  printf("Thread2 ending.\n");
  pthread_exit(0);
}

int main(int argc, char *argv[])
{
  int ret;
  pthread_t thread2_id;
  void *retval;

  printf("\n\n   ***   test_mt1   ***\n\n");
  printf("Basic test of multithreading\n\n");
  
  if (pthread_create(&thread2_id, NULL, thread2, NULL)) {
    perror("pthread_create");
    exit(1);
  }
  printf("Thread2 created. Waiting for termination...\n");
  ret = pthread_join(thread2_id, &retval);
  if (ret) {
    if (ret!=ESRCH) {
      perror("pthread_join");
      exit(1);
    }
    else
      printf("Thread2 already terminated\n");
  }
  else
    printf("Thread2 exited with %x value\n", retval);
}
